/**
 * Copyright (c) 2000-2013 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package it.tref.liferay.mapit.map.service;

import com.liferay.portal.kernel.bean.PortletBeanLocatorUtil;
import com.liferay.portal.kernel.util.ReferenceRegistry;
import com.liferay.portal.service.InvokableLocalService;

/**
 * Provides the local service utility for PluginPortletPreferences. This utility wraps
 * {@link it.tref.liferay.mapit.map.service.impl.PluginPortletPreferencesLocalServiceImpl} and is the
 * primary access point for service operations in application layer code running
 * on the local server. Methods of this service will not have security checks
 * based on the propagated JAAS credentials because this service can only be
 * accessed from within the same VM.
 *
 * @author
 * @see PluginPortletPreferencesLocalService
 * @see it.tref.liferay.mapit.map.service.base.PluginPortletPreferencesLocalServiceBaseImpl
 * @see it.tref.liferay.mapit.map.service.impl.PluginPortletPreferencesLocalServiceImpl
 * @generated
 */
public class PluginPortletPreferencesLocalServiceUtil {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify this class directly. Add custom service methods to {@link it.tref.liferay.mapit.map.service.impl.PluginPortletPreferencesLocalServiceImpl} and rerun ServiceBuilder to regenerate this class.
	 */

	/**
	* Adds the plugin portlet preferences to the database. Also notifies the appropriate model listeners.
	*
	* @param pluginPortletPreferences the plugin portlet preferences
	* @return the plugin portlet preferences that was added
	* @throws SystemException if a system exception occurred
	*/
	public static it.tref.liferay.mapit.map.model.PluginPortletPreferences addPluginPortletPreferences(
		it.tref.liferay.mapit.map.model.PluginPortletPreferences pluginPortletPreferences)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().addPluginPortletPreferences(pluginPortletPreferences);
	}

	/**
	* Creates a new plugin portlet preferences with the primary key. Does not add the plugin portlet preferences to the database.
	*
	* @param pluginPortletPreferencesId the primary key for the new plugin portlet preferences
	* @return the new plugin portlet preferences
	*/
	public static it.tref.liferay.mapit.map.model.PluginPortletPreferences createPluginPortletPreferences(
		long pluginPortletPreferencesId) {
		return getService()
				   .createPluginPortletPreferences(pluginPortletPreferencesId);
	}

	/**
	* Deletes the plugin portlet preferences with the primary key from the database. Also notifies the appropriate model listeners.
	*
	* @param pluginPortletPreferencesId the primary key of the plugin portlet preferences
	* @return the plugin portlet preferences that was removed
	* @throws PortalException if a plugin portlet preferences with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static it.tref.liferay.mapit.map.model.PluginPortletPreferences deletePluginPortletPreferences(
		long pluginPortletPreferencesId)
		throws com.liferay.portal.kernel.exception.PortalException,
			com.liferay.portal.kernel.exception.SystemException {
		return getService()
				   .deletePluginPortletPreferences(pluginPortletPreferencesId);
	}

	/**
	* Deletes the plugin portlet preferences from the database. Also notifies the appropriate model listeners.
	*
	* @param pluginPortletPreferences the plugin portlet preferences
	* @return the plugin portlet preferences that was removed
	* @throws SystemException if a system exception occurred
	*/
	public static it.tref.liferay.mapit.map.model.PluginPortletPreferences deletePluginPortletPreferences(
		it.tref.liferay.mapit.map.model.PluginPortletPreferences pluginPortletPreferences)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService()
				   .deletePluginPortletPreferences(pluginPortletPreferences);
	}

	public static com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery() {
		return getService().dynamicQuery();
	}

	/**
	* Performs a dynamic query on the database and returns the matching rows.
	*
	* @param dynamicQuery the dynamic query
	* @return the matching rows
	* @throws SystemException if a system exception occurred
	*/
	@SuppressWarnings("rawtypes")
	public static java.util.List dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().dynamicQuery(dynamicQuery);
	}

	/**
	* Performs a dynamic query on the database and returns a range of the matching rows.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link it.tref.liferay.mapit.map.model.impl.PluginPortletPreferencesModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param dynamicQuery the dynamic query
	* @param start the lower bound of the range of model instances
	* @param end the upper bound of the range of model instances (not inclusive)
	* @return the range of matching rows
	* @throws SystemException if a system exception occurred
	*/
	@SuppressWarnings("rawtypes")
	public static java.util.List dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end) throws com.liferay.portal.kernel.exception.SystemException {
		return getService().dynamicQuery(dynamicQuery, start, end);
	}

	/**
	* Performs a dynamic query on the database and returns an ordered range of the matching rows.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link it.tref.liferay.mapit.map.model.impl.PluginPortletPreferencesModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param dynamicQuery the dynamic query
	* @param start the lower bound of the range of model instances
	* @param end the upper bound of the range of model instances (not inclusive)
	* @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	* @return the ordered range of matching rows
	* @throws SystemException if a system exception occurred
	*/
	@SuppressWarnings("rawtypes")
	public static java.util.List dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService()
				   .dynamicQuery(dynamicQuery, start, end, orderByComparator);
	}

	/**
	* Returns the number of rows that match the dynamic query.
	*
	* @param dynamicQuery the dynamic query
	* @return the number of rows that match the dynamic query
	* @throws SystemException if a system exception occurred
	*/
	public static long dynamicQueryCount(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().dynamicQueryCount(dynamicQuery);
	}

	/**
	* Returns the number of rows that match the dynamic query.
	*
	* @param dynamicQuery the dynamic query
	* @param projection the projection to apply to the query
	* @return the number of rows that match the dynamic query
	* @throws SystemException if a system exception occurred
	*/
	public static long dynamicQueryCount(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery,
		com.liferay.portal.kernel.dao.orm.Projection projection)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().dynamicQueryCount(dynamicQuery, projection);
	}

	public static it.tref.liferay.mapit.map.model.PluginPortletPreferences fetchPluginPortletPreferences(
		long pluginPortletPreferencesId)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService()
				   .fetchPluginPortletPreferences(pluginPortletPreferencesId);
	}

	/**
	* Returns the plugin portlet preferences with the primary key.
	*
	* @param pluginPortletPreferencesId the primary key of the plugin portlet preferences
	* @return the plugin portlet preferences
	* @throws PortalException if a plugin portlet preferences with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static it.tref.liferay.mapit.map.model.PluginPortletPreferences getPluginPortletPreferences(
		long pluginPortletPreferencesId)
		throws com.liferay.portal.kernel.exception.PortalException,
			com.liferay.portal.kernel.exception.SystemException {
		return getService()
				   .getPluginPortletPreferences(pluginPortletPreferencesId);
	}

	public static com.liferay.portal.model.PersistedModel getPersistedModel(
		java.io.Serializable primaryKeyObj)
		throws com.liferay.portal.kernel.exception.PortalException,
			com.liferay.portal.kernel.exception.SystemException {
		return getService().getPersistedModel(primaryKeyObj);
	}

	/**
	* Returns a range of all the plugin portlet preferenceses.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link it.tref.liferay.mapit.map.model.impl.PluginPortletPreferencesModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	* </p>
	*
	* @param start the lower bound of the range of plugin portlet preferenceses
	* @param end the upper bound of the range of plugin portlet preferenceses (not inclusive)
	* @return the range of plugin portlet preferenceses
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<it.tref.liferay.mapit.map.model.PluginPortletPreferences> getPluginPortletPreferenceses(
		int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().getPluginPortletPreferenceses(start, end);
	}

	/**
	* Returns the number of plugin portlet preferenceses.
	*
	* @return the number of plugin portlet preferenceses
	* @throws SystemException if a system exception occurred
	*/
	public static int getPluginPortletPreferencesesCount()
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().getPluginPortletPreferencesesCount();
	}

	/**
	* Updates the plugin portlet preferences in the database or adds it if it does not yet exist. Also notifies the appropriate model listeners.
	*
	* @param pluginPortletPreferences the plugin portlet preferences
	* @return the plugin portlet preferences that was updated
	* @throws SystemException if a system exception occurred
	*/
	public static it.tref.liferay.mapit.map.model.PluginPortletPreferences updatePluginPortletPreferences(
		it.tref.liferay.mapit.map.model.PluginPortletPreferences pluginPortletPreferences)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService()
				   .updatePluginPortletPreferences(pluginPortletPreferences);
	}

	/**
	* Returns the Spring bean ID for this bean.
	*
	* @return the Spring bean ID for this bean
	*/
	public static java.lang.String getBeanIdentifier() {
		return getService().getBeanIdentifier();
	}

	/**
	* Sets the Spring bean ID for this bean.
	*
	* @param beanIdentifier the Spring bean ID for this bean
	*/
	public static void setBeanIdentifier(java.lang.String beanIdentifier) {
		getService().setBeanIdentifier(beanIdentifier);
	}

	public static java.lang.Object invokeMethod(java.lang.String name,
		java.lang.String[] parameterTypes, java.lang.Object[] arguments)
		throws java.lang.Throwable {
		return getService().invokeMethod(name, parameterTypes, arguments);
	}

	public static it.tref.liferay.mapit.map.model.PluginPortletPreferences updatePreferences(
		long ownerId, int ownerType, long plid, java.lang.String portletId,
		java.lang.String plugin,
		javax.portlet.PortletPreferences portletPreferences)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService()
				   .updatePreferences(ownerId, ownerType, plid, portletId,
			plugin, portletPreferences);
	}

	public static it.tref.liferay.mapit.map.model.PluginPortletPreferences updatePreferences(
		long ownerId, int ownerType, long plid, java.lang.String portletId,
		java.lang.String plugin, java.lang.String xml)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService()
				   .updatePreferences(ownerId, ownerType, plid, portletId,
			plugin, xml);
	}

	public static java.util.List<it.tref.liferay.mapit.map.model.PluginPortletPreferences> getPortletPreferences(
		int ownerType, long plid, java.lang.String portletId, int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService()
				   .getPortletPreferences(ownerType, plid, portletId, start, end);
	}

	public static it.tref.liferay.mapit.map.model.PluginPortletPreferences getPortletPreferences(
		long ownerId, int ownerType, long plid, java.lang.String portletId,
		java.lang.String plugin)
		throws com.liferay.portal.kernel.exception.PortalException,
			com.liferay.portal.kernel.exception.SystemException {
		return getService()
				   .getPortletPreferences(ownerId, ownerType, plid, portletId,
			plugin);
	}

	public static javax.portlet.PortletPreferences getPreferences(
		long companyId, long ownerId, int ownerType, long plid,
		java.lang.String portletId, java.lang.String plugin)
		throws com.liferay.portal.kernel.exception.PortalException,
			com.liferay.portal.kernel.exception.SystemException {
		return getService()
				   .getPreferences(companyId, ownerId, ownerType, plid,
			portletId, plugin);
	}

	public static void clearService() {
		_service = null;
	}

	public static PluginPortletPreferencesLocalService getService() {
		if (_service == null) {
			InvokableLocalService invokableLocalService = (InvokableLocalService)PortletBeanLocatorUtil.locate(ClpSerializer.getServletContextName(),
					PluginPortletPreferencesLocalService.class.getName());

			if (invokableLocalService instanceof PluginPortletPreferencesLocalService) {
				_service = (PluginPortletPreferencesLocalService)invokableLocalService;
			}
			else {
				_service = new PluginPortletPreferencesLocalServiceClp(invokableLocalService);
			}

			ReferenceRegistry.registerReference(PluginPortletPreferencesLocalServiceUtil.class,
				"_service");
		}

		return _service;
	}

	/**
	 * @deprecated As of 6.2.0
	 */
	public void setService(PluginPortletPreferencesLocalService service) {
	}

	private static PluginPortletPreferencesLocalService _service;
}