<%@page import="com.liferay.portal.kernel.json.JSONException"%>
<%@page import="com.liferay.portal.kernel.json.JSONFactoryUtil"%>
<%@page import="com.liferay.portal.kernel.json.JSONArray"%>
<%@page import="com.liferay.portal.kernel.portlet.LiferayWindowState"%>
<%@page import="it.tref.liferay.mapit.map.constants.PortletKeys"%>
<%@page import="com.liferay.portal.security.permission.ResourceActionsUtil"%>
<%@page import="com.liferay.portal.util.PortalUtil"%>

<%@include file="/html/map/init.jsp" %>

<%

//check map styles
if (mapType.equals(Constants.MapTypeValue.GOOGLE_MAP)) {
  try {
  	JSONArray jsonArray = JSONFactoryUtil.createJSONArray(mapStyles);
   	mapStyles = jsonArray.toString();
  } catch (JSONException e) {
    mapStyles = null;
  }
}
%>

<liferay-portlet:resourceURL var="assetEntriesURL" id="assetEntries" />

<liferay-portlet:renderURL var="featureClickURL" windowState="<%=LiferayWindowState.POP_UP.toString() %>">
	<liferay-portlet:param name="mvcPath" value="/html/map/feature_selected.jsp"/>
</liferay-portlet:renderURL>



<liferay-util:buffer var="mapitBuffer">
		<c:choose>
		<c:when test="<%=mapType.equals(Constants.MapTypeValue.OPEN_STREET_MAP)%>">
			var mapType = Liferay.MapItMap.MAP_TYPE.OPEN_STREET_MAP;
		</c:when>
		<c:when test="<%=mapType.equals(Constants.MapTypeValue.GOOGLE_MAP)%>">
			var mapType = Liferay.MapItMap.MAP_TYPE.GOOGLE_MAP;
		</c:when>
		<c:when test="<%=mapType.equals(Constants.MapTypeValue.BING_MAP)%>">
			var mapType = Liferay.MapItMap.MAP_TYPE.BING_MAP;
		</c:when>
		<c:when test="<%=mapType.equals(Constants.MapTypeValue.BASE_MAP)%>">
			var mapType = Liferay.MapItMap.MAP_TYPE.BASE;
		</c:when>
		<c:when test="<%=mapType.equals(Constants.MapTypeValue.BASE_MAP_LABEL)%>">
			var mapType = Liferay.MapItMap.MAP_TYPE.BASE_LABEL;
		</c:when>
	</c:choose>
	
	<c:choose>
		<c:when test="<%=zoomType.equals(Constants.ZoomTypeValue.SIMPLE)%>">
			var zoomType = Liferay.MapItMap.ZOOM_TYPE.ZOOM;
		</c:when>
		<c:when test="<%=zoomType.equals(Constants.ZoomTypeValue.COMPACT)%>">
			var zoomType = Liferay.MapItMap.ZOOM_TYPE.PAN_ZOOM;
		</c:when>
		<c:when test="<%=zoomType.equals(Constants.ZoomTypeValue.FULL)%>">
			var zoomType = Liferay.MapItMap.ZOOM_TYPE.PAN_ZOOM_BAR;
		</c:when>
		<c:otherwise>
			var zoomType = null;
		</c:otherwise>
	</c:choose>
	
	<c:choose>
		<c:when test="<%=mapType.equals(Constants.MapTypeValue.GOOGLE_MAP)%>">
			var mapStyles = <%= mapStyles %>;
		</c:when>
		<c:otherwise>
			var mapStyles = null;
		</c:otherwise>
	</c:choose>
	new Liferay.MapItMap({
		id: '<portlet:namespace />map',
		portletId: '<%= themeDisplay.getPortletDisplay().getId() %>',
		mapType: mapType,
		apiKey: '<%= apiKey %>',
		apiVersion: '<%= apiVersion %>',
		mapStyles: mapStyles,
		center: {
			latitude: '<%= centerLatitude %>',
			longitude: '<%= centerLongitude %>',
			zoom: '<%= centerZoom %>',
			geoLocation: <%= geoBrowser %>
		},
		saveLastPosition: <%= saveLastPosition %>,
		controls: {
			layerSwitch: <%= layerSwitch %>,
			fullScreen: <%= fullScreen %>,
			navToolbar: <%= navToolbar %>,
			mousePosition: <%= mousePosition %>,
			scale: <%= scale %>,
			zoomType: zoomType,
			home: <%= home %>,
			overviewMap: <%= overviewMap %>
		},
		on: {
			featureSelected: function(event) {
				<c:if test="<%= !noPopup %>">
				 	var mapItMap = Liferay.MapItMap.get('<%= themeDisplay.getPortletDisplay().getId() %>');
				 	var feature = event.feature;
				 	mapItMap.showPopup({
		    			layerId: feature.layer.id,
		    			featureId: feature.id,
		    			latitude: feature.latitude,
		    			longitude: feature.longitude,
		   				url: '<%= featureClickURL %>',
		   				parameters: {
		   					<portlet:namespace/>classNameId: feature.attributes.classNameId,
							<portlet:namespace/>classPK: feature.attributes.classPK
		   				}
		    		});
			 	</c:if>
			},
			featureUnselected: function(event) {
				<c:if test="<%= !noPopup %>">
					var mapItMap = Liferay.MapItMap.get('<%= themeDisplay.getPortletDisplay().getId() %>');
		 			mapItMap.hidePopup({layerId: event.feature.layer.id, featureId: event.feature.id});
		 		</c:if>
			},
			layerReady: function(event) {
				
				<% for (String pluginId : pluginIds)  { %>
					Liferay.fire('<%= "mapItMapLayerReady" + StringPool.PERIOD + pluginId %>', event);
				<% } %>
				
				var mapItMap = Liferay.MapItMap.get('<%= themeDisplay.getPortletDisplay().getId() %>');
				
				var count = 1;
				if (typeof (mapItMap.get('mapItMapLayersReadyCount')) != 'undefined') {
					count = mapItMap.get('mapItMapLayersReadyCount') + 1;
				}
				mapItMap.set('mapItMapLayersReadyCount', count);
				
				if (count == <%= classNameIds.length %>) {
	
					<% for (String pluginId : pluginIds)  { %>
						Liferay.fire('<%= "mapItMapAllLayersReady" + StringPool.PERIOD + pluginId %>', {
							portletId: event.portletId
						});
					<% } %>
					
					mapItMap.set('mapItMapLayersReadyCount', 0);
				}
			},
			ready: function(event) {
				
				<c:if test="<%=pluginIds.length > 0 %>">
				
					<%for (String pluginId : pluginIds)  { %>
					
						Liferay.fire('<%= "mapItMapReady" + StringPool.PERIOD + pluginId %>', event);
					
					<% } %>
				
				</c:if>
			
				<c:if test="<%=classNameIds.length > 0 %>">
		
					var mapItMap = Liferay.MapItMap.get('<%= themeDisplay.getPortletDisplay().getId() %>');
					<%
					for (long classNameId : classNameIds) {
					  	try {
					  		String className = PortalUtil.getClassName(classNameId);
							String layerName = ResourceActionsUtil.getModelResource(pageContext, className);
					%>
							var parameters = { <%=renderResponse.getNamespace() + "classNameId: " + classNameId %> };
							mapItMap.addLayer('<%=layerName%>', '<%=assetEntriesURL%>', parameters, {
								fixed: <%= ignoreBbox %>
							});	
					<%		
					  	} catch (Exception e) { }
					}
					%>
				
				</c:if>	
			}
		}
	}).render();
</liferay-util:buffer>

<aui:script use="liferay-mapit-map">
 <%=mapitBuffer %>
</aui:script>

<c:if test="<%=showMapCode %>">
	<div class="code">
		<%=mapitBuffer %>
	</div>
</c:if>